import java.lang.reflect.*;

/**
   This program computes sqrt(9.0) the hard way,
   using reflection.
*/
public class HardSqrt
{
   public static void main(String[] args)
   throws NoSuchMethodException, IllegalAccessException, InvocationTargetException, ClassNotFoundException
   {
      String className = "java.lang.Math";
      String methodName = "sqrt";
      String firstArgType = "double";

      Class<?> c = Class.forName( className );

      firstArgType =  double.class.getName();
      System.out.println( firstArgType );

    //Method m = c.getDeclaredMethod( methodName, Class.forName("double") );                // WRONG
    //Method m = c.getDeclaredMethod( methodName, Class.forName("double.class") );          // WRONG
    //Method m = c.getDeclaredMethod( methodName, Class.forName( double.class.getName()) ); // WRONG

    //Method m = c.getDeclaredMethod( methodName, Double.class );                           // WRONG
    //Method m = c.getDeclaredMethod( methodName, double.class );
    //Method m = c.getDeclaredMethod( methodName, Double.TYPE );

      Class<?> firstArgClass;

      if      (firstArgType.equals("byte"))    firstArgClass = byte.class;
      else if (firstArgType.equals("char"))    firstArgClass = char.class;
      else if (firstArgType.equals("short"))   firstArgClass = short.class;
      else if (firstArgType.equals("int"))     firstArgClass = int.class;
      else if (firstArgType.equals("long"))    firstArgClass = long.class;
      else if (firstArgType.equals("float"))   firstArgClass = float.class;
      else if (firstArgType.equals("double"))  firstArgClass = double.class;
      else if (firstArgType.equals("boolean")) firstArgClass = boolean.class;
      else
      {
         firstArgClass = Class.forName(firstArgType);
	  }
      Method m = c.getDeclaredMethod( methodName, firstArgClass );

      Object o = m.invoke( null, new Double(9.0) );
      double r = ((Double)o).doubleValue();
      System.out.println(  "r = " + r );
   }
}